/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatConnectorFormAllOf{}

// SnapchatConnectorFormAllOf struct for SnapchatConnectorFormAllOf
type SnapchatConnectorFormAllOf struct {
	// OAuth Identifier
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label
	Label *string `json:"label,omitempty"`
	// Snapchat Organization identifier
	OrganizationId *string `json:"organizationId,omitempty"`
	// Snapchat Ad Account identifier
	AccountId *string `json:"accountId,omitempty"`
	// Metrics
	Metrics []string `json:"metrics,omitempty"`
	// Labels
	Labels []string `json:"labels,omitempty"`
	// breakdown
	Breakdown *string `json:"breakdown,omitempty"`
	// Data range
	DateRange *string `json:"dateRange,omitempty"`
	// action_report_time
	ActionReportTime *string `json:"action_report_time,omitempty"`
	// swipe_up_attribution_window
	SwipeUpAttributionWindow *string `json:"swipe_up_attribution_window,omitempty"`
	// view_attribution_window
	ViewAttributionWindow *string `json:"view_attribution_window,omitempty"`
}

// NewSnapchatConnectorFormAllOf instantiates a new SnapchatConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatConnectorFormAllOf() *SnapchatConnectorFormAllOf {
	this := SnapchatConnectorFormAllOf{}
	return &this
}

// NewSnapchatConnectorFormAllOfWithDefaults instantiates a new SnapchatConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatConnectorFormAllOfWithDefaults() *SnapchatConnectorFormAllOf {
	this := SnapchatConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SnapchatConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *SnapchatConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *SnapchatConnectorFormAllOf) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *SnapchatConnectorFormAllOf) SetAccountId(v string) {
	o.AccountId = &v
}

// GetMetrics returns the Metrics field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetMetrics() []string {
	if o == nil || IsNil(o.Metrics) {
		var ret []string
		return ret
	}
	return o.Metrics
}

// GetMetricsOk returns a tuple with the Metrics field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetMetricsOk() ([]string, bool) {
	if o == nil || IsNil(o.Metrics) {
		return nil, false
	}
	return o.Metrics, true
}

// HasMetrics returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasMetrics() bool {
	if o != nil && !IsNil(o.Metrics) {
		return true
	}

	return false
}

// SetMetrics gets a reference to the given []string and assigns it to the Metrics field.
func (o *SnapchatConnectorFormAllOf) SetMetrics(v []string) {
	o.Metrics = v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *SnapchatConnectorFormAllOf) SetLabels(v []string) {
	o.Labels = v
}

// GetBreakdown returns the Breakdown field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetBreakdown() string {
	if o == nil || IsNil(o.Breakdown) {
		var ret string
		return ret
	}
	return *o.Breakdown
}

// GetBreakdownOk returns a tuple with the Breakdown field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetBreakdownOk() (*string, bool) {
	if o == nil || IsNil(o.Breakdown) {
		return nil, false
	}
	return o.Breakdown, true
}

// HasBreakdown returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasBreakdown() bool {
	if o != nil && !IsNil(o.Breakdown) {
		return true
	}

	return false
}

// SetBreakdown gets a reference to the given string and assigns it to the Breakdown field.
func (o *SnapchatConnectorFormAllOf) SetBreakdown(v string) {
	o.Breakdown = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *SnapchatConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

// GetActionReportTime returns the ActionReportTime field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetActionReportTime() string {
	if o == nil || IsNil(o.ActionReportTime) {
		var ret string
		return ret
	}
	return *o.ActionReportTime
}

// GetActionReportTimeOk returns a tuple with the ActionReportTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetActionReportTimeOk() (*string, bool) {
	if o == nil || IsNil(o.ActionReportTime) {
		return nil, false
	}
	return o.ActionReportTime, true
}

// HasActionReportTime returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasActionReportTime() bool {
	if o != nil && !IsNil(o.ActionReportTime) {
		return true
	}

	return false
}

// SetActionReportTime gets a reference to the given string and assigns it to the ActionReportTime field.
func (o *SnapchatConnectorFormAllOf) SetActionReportTime(v string) {
	o.ActionReportTime = &v
}

// GetSwipeUpAttributionWindow returns the SwipeUpAttributionWindow field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetSwipeUpAttributionWindow() string {
	if o == nil || IsNil(o.SwipeUpAttributionWindow) {
		var ret string
		return ret
	}
	return *o.SwipeUpAttributionWindow
}

// GetSwipeUpAttributionWindowOk returns a tuple with the SwipeUpAttributionWindow field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetSwipeUpAttributionWindowOk() (*string, bool) {
	if o == nil || IsNil(o.SwipeUpAttributionWindow) {
		return nil, false
	}
	return o.SwipeUpAttributionWindow, true
}

// HasSwipeUpAttributionWindow returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasSwipeUpAttributionWindow() bool {
	if o != nil && !IsNil(o.SwipeUpAttributionWindow) {
		return true
	}

	return false
}

// SetSwipeUpAttributionWindow gets a reference to the given string and assigns it to the SwipeUpAttributionWindow field.
func (o *SnapchatConnectorFormAllOf) SetSwipeUpAttributionWindow(v string) {
	o.SwipeUpAttributionWindow = &v
}

// GetViewAttributionWindow returns the ViewAttributionWindow field value if set, zero value otherwise.
func (o *SnapchatConnectorFormAllOf) GetViewAttributionWindow() string {
	if o == nil || IsNil(o.ViewAttributionWindow) {
		var ret string
		return ret
	}
	return *o.ViewAttributionWindow
}

// GetViewAttributionWindowOk returns a tuple with the ViewAttributionWindow field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorFormAllOf) GetViewAttributionWindowOk() (*string, bool) {
	if o == nil || IsNil(o.ViewAttributionWindow) {
		return nil, false
	}
	return o.ViewAttributionWindow, true
}

// HasViewAttributionWindow returns a boolean if a field has been set.
func (o *SnapchatConnectorFormAllOf) HasViewAttributionWindow() bool {
	if o != nil && !IsNil(o.ViewAttributionWindow) {
		return true
	}

	return false
}

// SetViewAttributionWindow gets a reference to the given string and assigns it to the ViewAttributionWindow field.
func (o *SnapchatConnectorFormAllOf) SetViewAttributionWindow(v string) {
	o.ViewAttributionWindow = &v
}

func (o SnapchatConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organizationId"] = o.OrganizationId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.Metrics) {
		toSerialize["metrics"] = o.Metrics
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	if !IsNil(o.Breakdown) {
		toSerialize["breakdown"] = o.Breakdown
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.ActionReportTime) {
		toSerialize["action_report_time"] = o.ActionReportTime
	}
	if !IsNil(o.SwipeUpAttributionWindow) {
		toSerialize["swipe_up_attribution_window"] = o.SwipeUpAttributionWindow
	}
	if !IsNil(o.ViewAttributionWindow) {
		toSerialize["view_attribution_window"] = o.ViewAttributionWindow
	}
	return toSerialize, nil
}

type NullableSnapchatConnectorFormAllOf struct {
	value *SnapchatConnectorFormAllOf
	isSet bool
}

func (v NullableSnapchatConnectorFormAllOf) Get() *SnapchatConnectorFormAllOf {
	return v.value
}

func (v *NullableSnapchatConnectorFormAllOf) Set(val *SnapchatConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatConnectorFormAllOf(val *SnapchatConnectorFormAllOf) *NullableSnapchatConnectorFormAllOf {
	return &NullableSnapchatConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableSnapchatConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
